<?php
// +-----------------------------------------------------------------------+
// | file          : mailtousers.php
// | last update   : 2005-12-06
// | last modifier : Ruben
// | revision      : 1.0.0.2
// +-----------------------------------------------------------------------+

// +-----------------------------------------------------------------------+
// | include
// +-----------------------------------------------------------------------+

if (!defined('PHPWG_ROOT_PATH'))
{
  die ("Hacking attempt!");
}
include_once(PHPWG_ROOT_PATH.'admin/include/isadmin.inc.php');
include_once(PHPWG_ROOT_PATH.'admin/include/functions.php');

include_once(PHPWG_ROOT_PATH.'include/common.inc.php');
include_once(PHPWG_ROOT_PATH.'include/functions_news_notification.inc.php');
include_once(PHPWG_ROOT_PATH.'include/functions_mail.inc.php');

// A mettre dans constants.php par la suite
define('USER_MAIL_NOTIFICATION_TABLE', $prefixeTable.'user_mail_notification');

// +-----------------------------------------------------------------------+
// | functions
// +-----------------------------------------------------------------------+
/*
 * Search an available check_key
 *
 * It's a copy of function find_available_feed_id
 *
 * @return string feed identifier
 */
function find_available_check_key()
{
  while (true)
  {
    $key = generate_key(128);
    $query = '
select
  count(*)
from
  '.USER_MAIL_NOTIFICATION_TABLE.'
where
  check_key = \''.$key.'\';';

    list($count) = mysql_fetch_row(pwg_query($query));
    if ($count == 0)
    {
      return $key;
    }
  }
}

/*
 * Updating News users
 */
function UpdateDataUserMailNotification()
{
/*  $query = '
insert into '.USER_MAIL_NOTIFICATION_TABLE.'
  (user_id, enabled)
  (select id, \'false\' from '.USERS_TABLE.'
  where mail_address is not null and id not in (select user_id from '.USER_MAIL_NOTIFICATION_TABLE.'))
;';
  pwg_query($query);*/

  global $conf, $page;

  $query = '
select
  id user_id, username, mail_address
from
  '.USERS_TABLE.'
where
  mail_address is not null and 
  id not in (select user_id from '.USER_MAIL_NOTIFICATION_TABLE.')
order by
  id;';

  $result = pwg_query($query);

  if (mysql_num_rows($result) > 0)
  {
    $inserts = array();

    while ($row = mysql_fetch_array($result))
    {
      array_push($inserts, array('user_id' => $row['user_id'],
                                 'check_key' => find_available_check_key(),
                                 'enabled' => ($conf['default_value_user_mail_notification_enabled'] == true ? 'true' : 'false')));
      array_push($page['infos'], sprintf(l10n('User %s [%s] added.'), $row['username'], $row['mail_address']));
    }

    mass_inserts(USER_MAIL_NOTIFICATION_TABLE, array('user_id', 'check_key', 'enabled'), $inserts);
  }
}

/*
 * Updating News users
 */
function SendAllUserMailNotification()
{
  global $conf, $conf_mail, $page, $user;
  list($dbnow) = mysql_fetch_row(pwg_query('SELECT NOW();'));

  $query = '
select
  N.user_id, U.username, U.mail_address, N.last_send
from
  '.USER_MAIL_NOTIFICATION_TABLE.' as N,
  '.USERS_TABLE.' as U
where
  N.user_id =  U.id and
  N.enabled = \'true\' and
  U.mail_address is not null
order by
  user_id;';

  $result = pwg_query($query);

  if (mysql_num_rows($result) > 0)
  {
    $error_on_mail_count = 0;
    $sended_mail_count = 0;
    $datas = array();
    // Save $user array (include/user.inc.php has been executed)
    $sav_mailtousers_user = $user;

    while ($row = mysql_fetch_array($result))
    {
      $user = array();
      $user['id'] = $row['user_id'];
      $user = array_merge($user, getuserdata($user['id'], true));

      $message = '';
      $news = news($row['last_send'], $dbnow);
      if (count($news) > 0)
      {
        $subject = '['.$conf['gallery_title'].']: '.l10n('New elements added');
        $message .= $row['username'].",\n\n";

        if (!is_null($row['last_send']))
          $message .= sprintf(l10n('New elements were added between %s and %s:'), $row['last_send'], $dbnow);
        else
          $message .= sprintf(l10n('New elements were added on %s:'), $dbnow);
        $message .= "\n";

        foreach ($news as $line)
        {
          $message .= '  o '.$line."\n";
        }

        $message .= "\n".sprintf(l10n('Go to %s %s.'), $conf['gallery_title'], $conf['gallery_url'])."\n\n";
        $message .= "\n".sprintf(l10n('To unsubscribe send a message to %s.'), $conf_mail['email_webmaster'])."\n\n";

        if (pwg_mail(FormatEmail($row['username'], $row['mail_address']), '', $subject, $message))
        {
          $sended_mail_count += 1;
          array_push($page['infos'], sprintf(l10n('Mail sended to %s [%s].'), $row['username'], $row['mail_address']));
          $data = array('user_id' => $row['user_id'],
                        'last_send' => $dbnow);
          array_push($datas, $data);
        }
        else
        {
          $error_on_mail_count += 1;
          array_push($page['errors'], sprintf(l10n('Error when sending email to %s [%s].'), $row['username'], $row['mail_address']));
        }
      }
    }

    // Restore $user array (include/user.inc.php has been executed)
    $user = $sav_mailtousers_user;

    mass_updates(
      USER_MAIL_NOTIFICATION_TABLE,
      array(
        'primary' => array('user_id'),
        'update' => array('last_send')
       ),
       $datas
       );

    if ($error_on_mail_count != 0)
    {
      array_push($page['errors'], sprintf(l10n('%d mails were not sended.'), $error_on_mail_count));
    }
    else
    {
      if ($sended_mail_count == 0)
        array_push($page['infos'], l10n('No mail to send.'));
      else
        array_push($page['infos'], sprintf(l10n('%d mails were sended.'), $sended_mail_count));
    }
  }
  else
  {
    array_push($page['errors'], l10n('No user to send notifications by mail.'));
  }
}

// +-----------------------------------------------------------------------+
// | Main
// +-----------------------------------------------------------------------+
UpdateDataUserMailNotification();
SendAllUserMailNotification();


// +-----------------------------------------------------------------------+
// |                        template initialization                        |
// +-----------------------------------------------------------------------+

$title = l10n('Send mail to users');

// +-----------------------------------------------------------------------+
// |                        infos & errors display                         |
// +-----------------------------------------------------------------------+

/*echo '<pre>';

if (count($page['errors']) != 0)
{
  echo "\n\nErrors:\n";
  foreach ($page['errors'] as $error)
  {
    echo $error."\n";
  }
}

if (count($page['infos']) != 0)
{
  echo "\n\nInformations:\n";
  foreach ($page['infos'] as $info)
  {
    echo $info."\n";
  }
}

echo '</pre>';
*/
?>